<?php
/**
 * Filename: _database_customsearch.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

class sbpDatabaseCustomsearch extends sbpDatabase {
	var $tableCs;
	var $tableCs_version;

	var $tableCsImpressions;
	var $tableCsImpressions_version;

	var $tableCsStyles;

	var $tableCsOptions;
	var $tableCsOptionsDefaults;

	function __construct() {
		parent::__construct();

		$this->tableCs                      = $this->tableName .'_cs';
		$this->tableCs_version              = '1.0.0';

		$this->tableCsImpressions           = $this->tableCs .'_impressions';
		$this->tableCsImpressions_version   = '1.0.0';

		$this->tableCsStyles                = $this->tableCs .'_styles';

		$this->tableCsOptions               = $this->tableCs .'_options';
		$this->tableCsOptionsDefaults       = array(
			'privacy' => '<p>We Do Not Collect Your Personal Information - We Simply Pass It To The Next Page For Your Convenience. Please Read All Third Party Offers Carefully</p>'
		);
	}

	function install() {
		$this->_installTableCsOptions();
		$this->_installTableCsImpressions();
		$this->_installTableCs();
	}

		function _installTableCsOptions() {
			$options = get_option($this->tableCsOptions);
			if (!is_array($options) || is_array($options)) {
				update_option($this->tableCsOptions, $this->tableCsOptionsDefaults);
			}
		}

		function _installTableCsImpressions() {
			$version = get_option($this->tableCsImpressions);
            if ($version != $this->tableCsImpressions_version) {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCsImpressions .'_backup"') == $this->tableCsImpressions .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableCsImpressions .'_backup_2` LIKE `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableCsImpressions .'_backup_2` SELECT * FROM `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q3);
                }


                if ($this->tableCsImpressions_version == '1.0.0') {
                    $table = 'CREATE TABLE `'. $this->tableCsImpressions .'` (
                        `csimpressionsid`   INT(10)         NOT NULL AUTO_INCREMENT PRIMARY KEY,
                        `csid`              INT(10)         NOT NULL DEFAULT 0,

                        `created`           DATETIME        DEFAULT "0000-00-00 00:00:00",
						`modified`          DATETIME        DEFAULT "0000-00-00 00:00:00",
						`ip`                VARCHAR(255)    NOT NULL DEFAULT "127.0.0.1",
						`status`            INT(5)          NOT NULL DEFAULT 1
                    ) '. $this->tableCollation;
                }
                $this->execTable($table);


                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCsImpressions .'_backup_2"') == $this->tableCsImpressions .'_backup_2') {
                    $q = 'SELECT * FROM `'. $this->tableCsImpressions .'_backup_2`';
                    $res = $this->db->get_results($q, ARRAY_A);
                    if (0 != count($res)) {
                        foreach ($res as $data) {
                            if ($version == '1.0.0') {
                                $q2 = 'INSERT INTO `'. $this->tableCsImpressions .'` (
                                    `csimpressionsid`, `csid`,
                                    `created`, `modified`, `ip`, `status`
                                ) VALUES (
                                    "'. $data['csimpressionsid'] .'", "'. $data['csid'] .'",
                                    "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'"
                                )';
                            }
                            $this->db->query($q2);
                        }
                    }

                    $q3 = 'DROP TABLE `'. $this->tableCsImpressions .'_backup_2`';
                    $this->db->query($q3);
                }
            }
            else {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCsImpressions .'_backup"') == $this->tableCsImpressions .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableCsImpressions .'` LIKE `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableCsImpressions .'` SELECT * FROM `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableCsImpressions .'_backup`';
                    $this->db->query($q3);
                }
            }
            update_option($this->tableCsImpressions, $this->tableCsImpressions_version);
		}

		function _installTableCs() {
			$version = get_option($this->tableCs);
            if ($version != $this->tableCs_version) {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCs .'_backup"') == $this->tableCs .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableCs .'_backup_2` LIKE `'. $this->tableCs .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableCs .'_backup_2` SELECT * FROM `'. $this->tableCs .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableCs .'_backup`';
                    $this->db->query($q3);
                }


                if ($this->tableCs_version == '1.0.0') {
                    $table = 'CREATE TABLE `'. $this->tableCs .'` (
                        `csid`          INT(10)         NOT NULL AUTO_INCREMENT PRIMARY KEY,
                        `name`          VARCHAR(255)    NOT NULL,

                        `content`       TEXT            NULL,
                        `title`         TEXT            NOT NULL,
                        `url`           VARCHAR(512)    NOT NULL,
                        `term`          VARCHAR(512)    NOT NULL,

                        `homepage`      INT(5)          NOT NULL DEFAULT 1,
                        `pages`         INT(5)          NOT NULL DEFAULT 2,
                        `pagesid`       VARCHAR(255)    NULL,
                        `posts`         INT(5)          NOT NULL DEFAULT 2,
                        `postsid`       VARCHAR(255)    NULL,

                        `track`         INT(5)          NOT NULL,
                        `clicks`        INT(5)          NOT NULL DEFAULT 0,

                        `created`       DATETIME        DEFAULT "0000-00-00 00:00:00",
						`modified`      DATETIME        DEFAULT "0000-00-00 00:00:00",
						`ip`            VARCHAR(255)    NOT NULL DEFAULT "127.0.0.1",
						`status`        INT(5)          NOT NULL DEFAULT 1
                    ) '. $this->tableCollation;
                }
                $this->execTable($table);


                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCs .'_backup_2"') == $this->tableCs .'_backup_2') {
                    $q = 'SELECT * FROM `'. $this->tableCs .'_backup_2`';
                    $res = $this->db->get_results($q, ARRAY_A);
                    if (0 != count($res)) {
                        foreach ($res as $data) {
                            if ($version == '1.0.0') {
                                $q2 = 'INSERT INTO `'. $this->tableCs .'` (
                                    `csid`, `name`,
                                    `content`, `title`, `url`, `term`,
                                    `homepage`, `pages`, `pagesid`, `posts`, `postsid`,
                                    `track`, `clicks`,
                                    `created`, `modified`, `ip`, `status`
                                ) VALUES (
                                    "'. $data['csid'] .'", "'. $data['name'] .'",
                                    "'. $data['content'] .'", "'. $data['title'] .'", "'. $data['url'] .'", "'. $data['term'] .'",
                                    "'. $data['homepage'] .'", "'. $data['pages'] .'", "'. $data['pagesid'] .'", "'. $data['posts'] .'", "'. $data['postsid'] .'",
                                    "'. $data['track'] .'", "'. $data['clicks'] .'",
                                    "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'"
                                )';
                            }
                            $this->db->query($q2);
                        }
                    }

                    $q3 = 'DROP TABLE `'. $this->tableCs .'_backup_2`';
                    $this->db->query($q3);
                }
            }
            else {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCs .'_backup"') == $this->tableCs .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableCs .'` LIKE `'. $this->tableCs .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableCs .'` SELECT * FROM `'. $this->tableCs .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableCs .'_backup`';
                    $this->db->query($q3);
                }
            }
            update_option($this->tableCs, $this->tableCs_version);
		}

	function uninstall() {
		$this->_uninstallTableCsOptions();
		$this->_uninstallTableCsImpressions();
		$this->_uninstallTableCs();
	}

		function _uninstallTableCsOptions() {
			delete_option($this->tableCsOptions);
		}

		function _uninstallTableCsImpressions() {
			if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCsImpressions .'_backup"') != $this->tableCsImpressions .'_backup') {
                $q = 'CREATE TABLE `'. $this->tableCsImpressions .'_backup` LIKE `'. $this->tableCsImpressions .'`';
                $this->db->query($q);

                $q2 = 'INSERT INTO `'. $this->tableCsImpressions .'_backup` SELECT * FROM `'. $this->tableCsImpressions .'`';
                $this->db->query($q2);

                $q3 = 'DROP TABLE `'. $this->tableCsImpressions .'`';
                $this->db->query($q3);
            }
		}

		function _uninstallTableCs() {
			if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableCs .'_backup"') != $this->tableCs .'_backup') {
                $q = 'CREATE TABLE `'. $this->tableCs .'_backup` LIKE `'. $this->tableCs .'`';
                $this->db->query($q);

                $q2 = 'INSERT INTO `'. $this->tableCs .'_backup` SELECT * FROM `'. $this->tableCs .'`';
                $this->db->query($q2);

                $q3 = 'DROP TABLE `'. $this->tableCs .'`';
                $this->db->query($q3);
            }
		}



	function updateOptions() {
		if ($_POST) {
			$options    = get_option($this->tableCsOptions);
			if (!is_array($options) || is_array($options)) {
				$data = array(
					'privacy'   => $_POST['privacy']
				);
				update_option($this->tableCsOptions, $data);
			}

			die ('done');
		}
		die ('error');
	}

	function addCustomsearch() {
		if ($_POST) {
			$name                       = trim(strip_tags($_POST['name']));

			$contents                   = $_POST['contents'];
			$title                      = '';

			$url                        = trim(strip_tags($_POST['url']));
			$term                       = trim(strip_tags($_POST['term']));

			$homepage                   = (trim(strip_tags($_POST['homepage'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pages                      = (trim(strip_tags($_POST['pages'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pagesid                    = str_replace(', ', ',', trim(strip_tags($_POST['pagesid'])));
			$posts                      = (trim(strip_tags($_POST['posts'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$postsid                    = str_replace(', ', ',', trim(strip_tags($_POST['postsid'])));

			$track                      = SBP_ENABLED;
			$clicks                     = 0;
			$created                    = strftime('%Y-%m-%d %T');
			$modified                   = strftime('%Y-%m-%d %T');
			$ip                         = $_SERVER['REMOTE_ADDR'];
			$status                     = SBP_ENABLED;

			$shortcode_txtbox_width     = trim(strip_tags($_POST['sTxtboxWidth']));
			$shortcode_txtbox_padding   = trim(strip_tags($_POST['sTxtboxPadding']));
			$shortcode_txtbox_border    = trim(strip_tags($_POST['sTxtboxBorder']));
			$shortcode_txtbox_fontsize  = trim(strip_tags($_POST['sTxtboxFontsize']));

			$widget_txtbox_width        = trim(strip_tags($_POST['wTxtboxWidth']));
			$widget_txtbox_padding      = trim(strip_tags($_POST['wTxtboxPadding']));
			$widget_txtbox_border       = trim(strip_tags($_POST['wTxtboxBorder']));
			$widget_txtbox_fontsize     = trim(strip_tags($_POST['wTxtboxFontsize']));

			$btn                        = trim(strip_tags($_POST['btn']));
			$btn_bg                     = trim(strip_tags($_POST['btnBg']));
			$btn_padding                = trim(strip_tags($_POST['btnPadding']));
			$btn_color                  = trim(strip_tags($_POST['btnColor']));

			$q = 'INSERT INTO `'. $this->tableCs .'` (
				`csid`, `name`,
				`content`, `title`, `url`, `term`,
				`homepage`, `pages`, `pagesid`, `posts`, `postsid`,
				`track`, `clicks`,
				`created` ,`modified`, `ip`, `status`
			) VALUES (
				NULL, "'. $name .'",
				"'. $contents .'", "'. $title .'", "'. $url .'", "'. $term .'",
				"'. $homepage .'", "'. $pages .'", "'. $pagesid .'", "'. $posts .'", "'. $postsid .'",
				"'. $track .'", "'. $clicks .'",
				"'. $created .'", "'. $modified .'", "'. $ip .'", "'. $status .'"
			)';
			$this->db->query($q);
			$csid = $this->db->insert_id;

			$styles = array(
				'shortcode_txtbox_width'    => $shortcode_txtbox_width,
				'shortcode_txtbox_padding'  => $shortcode_txtbox_padding,
				'shortcode_txtbox_border'   => $shortcode_txtbox_border,
				'shortcode_txtbox_fontsize' => $shortcode_txtbox_fontsize,

				'widget_txtbox_width'       => $widget_txtbox_width,
				'widget_txtbox_padding'     => $widget_txtbox_padding,
				'widget_txtbox_border'      => $widget_txtbox_border,
				'widget_txtbox_fontsize'    => $widget_txtbox_fontsize,

				'btn'                       => $btn,
				'btn_bg'                    => $btn_bg,
				'btn_padding'               => $btn_padding,
				'btn_color'                 => $btn_color
			);
			update_option($this->tableCsStyles .'_'. $csid, $styles);

			die ('done');
		}
		die ('error');
	}

	function getAllCustomsearch() {
		$q = 'SELECT * FROM `'. $this->tableCs .'` ORDER BY `csid` DESC';
		return $this->db->get_results($q, ARRAY_A);
	}

	function getCustomsearchById($csid) {
		$q = 'SELECT * FROM `'. $this->tableCs .'` WHERE `csid`='. intval($csid);
		return $this->db->get_row($q, ARRAY_A);
	}

	function getCustomsearchByStatus($status) {
		$q = 'SELECT * FROM `'. $this->tableCs .'` WHERE `status`='. intval($status) .' ORDER BY `csid` DESC';
		return $this->db->get_results($q, ARRAY_A);
	}

	function updateCustomsearchStatus() {
		if ($_POST) {
			$csid   = intval($_POST['id']);
			$cs     = $this->getCustomsearchById($csid);
			if (0 != count($cs)) {
				$status = ($cs['status'] == SBP_ENABLED) ? SBP_DISABLED : SBP_ENABLED;

				$q = 'UPDATE `'. $this->tableCs .'` SET `status`='. intval($status) .' WHERE `csid`='. intval($csid);
				$this->db->query($q);
			}
			die ('done');
		}
		die ('error');
	}

	function deleteCustomsearch() {
		if ($_POST) {
			$csid   = intval($_POST['id']);
			$cs     = $this->getCustomsearchById($csid);
			if (0 != count($cs)) {
				$q = 'DELETE FROM `'. $this->tableCs .'` WHERE `csid`='. intval($csid);
				$this->db->query($q);

				$q2 = 'DELETE FROM `'. $this->tableCsImpressions .'` WHERE `csid`='. intval($csid);
				$this->db->query($q2);
			}
			die ('done');
		}
		die ('error');
	}

	function updateCustomersearch() {
		if ($_POST) {
			$csid                       = intval($_POST['id']);
			$name                       = trim(strip_tags($_POST['name']));

			$contents                   = $_POST['contents'];

			$url                        = trim(strip_tags($_POST['url']));
			$term                       = trim(strip_tags($_POST['term']));

			$homepage                   = (trim(strip_tags($_POST['homepage'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pages                      = (trim(strip_tags($_POST['pages'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pagesid                    = str_replace(', ', ',', trim(strip_tags($_POST['pagesid'])));
			$posts                      = (trim(strip_tags($_POST['posts'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$postsid                    = str_replace(', ', ',', trim(strip_tags($_POST['postsid'])));

			$modified                   = strftime('%Y-%m-%d %T');
			$ip                         = $_SERVER['REMOTE_ADDR'];

			$shortcode_txtbox_width     = trim(strip_tags($_POST['sTxtboxWidth']));
			$shortcode_txtbox_padding   = trim(strip_tags($_POST['sTxtboxPadding']));
			$shortcode_txtbox_border    = trim(strip_tags($_POST['sTxtboxBorder']));
			$shortcode_txtbox_fontsize  = trim(strip_tags($_POST['sTxtboxFontsize']));

			$widget_txtbox_width        = trim(strip_tags($_POST['wTxtboxWidth']));
			$widget_txtbox_padding      = trim(strip_tags($_POST['wTxtboxPadding']));
			$widget_txtbox_border       = trim(strip_tags($_POST['wTxtboxBorder']));
			$widget_txtbox_fontsize     = trim(strip_tags($_POST['wTxtboxFontsize']));

			$btn                        = trim(strip_tags($_POST['btn']));
			$btn_bg                     = trim(strip_tags($_POST['btnBg']));
			$btn_padding                = trim(strip_tags($_POST['btnPadding']));
			$btn_color                  = trim(strip_tags($_POST['btnColor']));


			$q = 'UPDATE `'. $this->tableCs .'` SET
				    `name`="'. $name .'", `content`="'. $contents .'",
				    `url`="'. $url .'", `term`="'. $term .'",
				    `homepage`="'. $homepage .'", `pages`="'. $pages .'", `pagesid`="'. $pagesid .'", `posts`="'. $posts .'", `postsid`="'. $postsid .'",
				    `modified`="'. $modified .'", `ip`="'. $ip .'"
				WHERE `csid`='. intval($csid);
			$this->db->query($q);


			$styles = array(
				'shortcode_txtbox_width'    => $shortcode_txtbox_width,
				'shortcode_txtbox_padding'  => $shortcode_txtbox_padding,
				'shortcode_txtbox_border'   => $shortcode_txtbox_border,
				'shortcode_txtbox_fontsize' => $shortcode_txtbox_fontsize,

				'widget_txtbox_width'       => $widget_txtbox_width,
				'widget_txtbox_padding'     => $widget_txtbox_padding,
				'widget_txtbox_border'      => $widget_txtbox_border,
				'widget_txtbox_fontsize'    => $widget_txtbox_fontsize,

				'btn'                       => $btn,
				'btn_bg'                    => $btn_bg,
				'btn_padding'               => $btn_padding,
				'btn_color'                 => $btn_color
			);
			update_option($this->tableCsStyles .'_'. $csid, $styles);

			die ('done');
		}
		die ('error');
	}

	function addImpression($data) {
		$q = 'INSERT INTO `'. $this->tableCsImpressions .'` (`csimpressionsid`, `csid`, `created`, `modified`, `ip`, `status`) VALUES (NULL, "'. $data['csid'] .'", "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'")';
		$this->db->query($q);
	}

	function addClicks() {
		if ($_POST) {
			$csid   = intval($_POST['id']);
			$cs     = $this->getCustomsearchById($csid);

			if (0 != count($cs)) {
				$clicks = $cs['clicks'] + 1;

				$q = 'UPDATE `'. $this->tableCs .'` SET `clicks`='. intval($clicks) .' WHERE `csid`='. intval($csid);
				$this->db->query($q);
			}

			die ('done');
		}
		die ('error');
	}

	function countImpressionsByCsid($csid) {
		$q = 'SELECT COUNT(*) FROM `'. $this->tableCsImpressions .'` WHERE `csid`='. intval($csid);
		return $this->db->get_var($q);
	}

	function resetStat() {
		if ($_POST) {
			$csid   = intval($_POST['id']);
			$cs     = $this->getCustomsearchById($csid);

			if (0 != count($cs)) {
				$q = 'UPDATE `'. $this->tableCs .'` SET `clicks`=0 WHERE `csid`='. intval($csid);
				$this->db->query($q);

				$q2 = 'DELETE FROM `'. $this->tableCsImpressions .'` WHERE `csid`='. intval($csid);
				$this->db->query($q2);
			}

			die ('done');
		}
		die ('error');
	}

	function resetAllStats() {
		if ($_POST) {
			$q = 'UPDATE `'. $this->tableCs .'` SET `clicks`=0';
			$this->db->query($q);

			$q2 = 'DELETE FROM `'. $this->tableCsImpressions .'`';
			$this->db->query($q2);

			die ('done');
		}
		die ('error');
	}
}