<?php
/**
 * Filename: _database_dropdown.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

class sbpDatabaseDropdown extends sbpDatabase {
	var $tableDrop;
	var $tableDropMaxCount;
	var $tableDrop_version;

	var $tableData;
	var $tableData_version;

	var $tableImpressions;
	var $tableImpressions_version;

	var $tableStyles;

	function __construct() {
		parent::__construct();

		$this->tableDrop                = $this->tableName .'_drop';
		$this->tableDropMaxCount        = 10;
		$this->tableDrop_version        = '1.0.0';

		$this->tableData                = $this->tableDrop .'_data';
		$this->tableData_version        = '1.0.0';

		$this->tableImpressions         = $this->tableDrop .'_impressions';
		$this->tableImpressions_version = '1.0.0';

		$this->tableStyles              = $this->tableDrop .'_styles';
	}

	function install() {
		$this->_installTableImpressions();
		$this->_installTableData();
		$this->_installTableDrop();
	}

		function _installTableImpressions() {
			$version = get_option($this->tableImpressions);
            if ($version != $this->tableImpressions_version) {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableImpressions .'_backup"') == $this->tableImpressions .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableImpressions .'_backup_2` LIKE `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableImpressions .'_backup_2` SELECT * FROM `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q3);
                }


                if ($this->tableImpressions_version == '1.0.0') {
                    $table = 'CREATE TABLE `'. $this->tableImpressions .'` (
                        `impressionsid`     INT(10)         NOT NULL AUTO_INCREMENT PRIMARY KEY,
                        `dropid`            INT(10)         NOT NULL DEFAULT 0,
                        `dataid`            INT(10)         NOT NULL DEFAULT 0,

                        `created`           DATETIME        DEFAULT "0000-00-00 00:00:00",
						`modified`          DATETIME        DEFAULT "0000-00-00 00:00:00",
						`ip`                VARCHAR(255)    NOT NULL DEFAULT "127.0.0.1",
						`status`            INT(5)          NOT NULL DEFAULT 1
                    ) '. $this->tableCollation;
                }
                $this->execTable($table);


                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableImpressions .'_backup_2"') == $this->tableImpressions .'_backup_2') {
                    $q = 'SELECT * FROM `'. $this->tableImpressions .'_backup_2`';
                    $res = $this->db->get_results($q, ARRAY_A);
                    if (0 != count($res)) {
                        foreach ($res as $data) {
                            if ($version == '1.0.0') {
                                $q2 = 'INSERT INTO `'. $this->tableImpressions .'` (
                                    `impressionsid`, `dropid`, `dataid`,
                                    `created`, `modified`, `ip`, `status`
                                ) VALUES (
                                    "'. $data['impressionsid'] .'", "'. $data['dropid'] .'", "'. $data['dataid'] .'",
                                    "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'"
                                )';
                            }
                            $this->db->query($q2);
                        }
                    }

                    $q3 = 'DROP TABLE `'. $this->tableImpressions .'_backup_2`';
                    $this->db->query($q3);
                }
            }
            else {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableImpressions .'_backup"') == $this->tableImpressions .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableImpressions .'` LIKE `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableImpressions .'` SELECT * FROM `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableImpressions .'_backup`';
                    $this->db->query($q3);
                }
            }
            update_option($this->tableImpressions, $this->tableImpressions_version);
		}

		function _installTableData() {
			$version = get_option($this->tableData);
            if ($version != $this->tableData_version) {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableData .'_backup"') == $this->tableData .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableData .'_backup_2` LIKE `'. $this->tableData .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableData .'_backup_2` SELECT * FROM `'. $this->tableData .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableData .'_backup`';
                    $this->db->query($q3);
                }


                if ($this->tableData_version == '1.0.0') {
                    $table = 'CREATE TABLE `'. $this->tableData .'` (
                        `dataid`        INT(10)         NOT NULL AUTO_INCREMENT PRIMARY KEY,
                        `dropid`        INT(10)         NOT NULL DEFAULT 0,

                        `name`          VARCHAR(255)    NOT NULL,
                        `url`           VARCHAR(255)    NOT NULL,
                        `clicks`        INT(5)          NOT NULL DEFAULT 0,

                        `created`       DATETIME        DEFAULT "0000-00-00 00:00:00",
						`modified`      DATETIME        DEFAULT "0000-00-00 00:00:00",
						`ip`            VARCHAR(255)    NOT NULL DEFAULT "127.0.0.1",
						`status`        INT(5)          NOT NULL DEFAULT 1
                    ) '. $this->tableCollation;
                }
                $this->execTable($table);


                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableData .'_backup_2"') == $this->tableData .'_backup_2') {
                    $q = 'SELECT * FROM `'. $this->tableData .'_backup_2`';
                    $res = $this->db->get_results($q, ARRAY_A);
                    if (0 != count($res)) {
                        foreach ($res as $data) {
                            if ($version == '1.0.0') {
                                $q2 = 'INSERT INTO `'. $this->tableData .'` (
                                    `dataid`, `dropid`,
                                    `name`, `url`, `clicks`,
                                    `created`, `modified`, `ip`, `status`
                                ) VALUES (
                                    "'. $data['dataid'] .'", "'. $data['dropid'] .'",
                                    "'. $data['name'] .'", "'. $data['url'] .'", "'. $data['clicks'] .'",
                                    "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'"
                                )';
                            }
                            $this->db->query($q2);
                        }
                    }

                    $q3 = 'DROP TABLE `'. $this->tableData .'_backup_2`';
                    $this->db->query($q3);
                }
            }
            else {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableData .'_backup"') == $this->tableData .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableData .'` LIKE `'. $this->tableData .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableData .'` SELECT * FROM `'. $this->tableData .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableData .'_backup`';
                    $this->db->query($q3);
                }
            }
            update_option($this->tableData, $this->tableData_version);
		}

		function _installTableDrop() {
			$version = get_option($this->tableDrop);
            if ($version != $this->tableDrop_version) {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableDrop .'_backup"') == $this->tableDrop .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableDrop .'_backup_2` LIKE `'. $this->tableDrop .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableDrop .'_backup_2` SELECT * FROM `'. $this->tableDrop .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableDrop .'_backup`';
                    $this->db->query($q3);
                }


                if ($this->tableDrop_version == '1.0.0') {
                    $table = 'CREATE TABLE `'. $this->tableDrop .'` (
                        `dropid`        INT(10)         NOT NULL AUTO_INCREMENT PRIMARY KEY,
                        `name`          VARCHAR(255)    NOT NULL,

                        `title`         VARCHAR(255)    NOT NULL,
                        `clicks`        INT(5)          NOT NULL DEFAULT 0,

                        `homepage`      INT(5)          NOT NULL DEFAULT 1,
                        `pages`         INT(5)          NOT NULL DEFAULT 2,
                        `pagesid`       VARCHAR(255)    NULL,
                        `posts`         INT(5)          NOT NULL DEFAULT 2,
                        `postsid`       VARCHAR(255)    NULL,

                        `created`       DATETIME        DEFAULT "0000-00-00 00:00:00",
						`modified`      DATETIME        DEFAULT "0000-00-00 00:00:00",
						`ip`            VARCHAR(255)    NOT NULL DEFAULT "127.0.0.1",
						`status`        INT(5)          NOT NULL DEFAULT 1
                    ) '. $this->tableCollation;
                }
                $this->execTable($table);


                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableDrop .'_backup_2"') == $this->tableDrop .'_backup_2') {
                    $q = 'SELECT * FROM `'. $this->tableDrop .'_backup_2`';
                    $res = $this->db->get_results($q, ARRAY_A);
                    if (0 != count($res)) {
                        foreach ($res as $data) {
                            if ($version == '1.0.0') {
                                $q2 = 'INSERT INTO `'. $this->tableDrop .'` (
                                    `dropid`, `name`,
                                    `title`, `clicks`,
                                    `homepage`, `pages`, `pagesid`, `posts`, `postsid`,
                                    `created`, `modified`, `ip`, `status`
                                ) VALUES (
                                    "'. $data['dropid'] .'", "'. $data['name'] .'",
                                    "'. $data['title'] .'", "'. $data['clicks'] .'"
                                    "'. $data['homepage'] .'", "'. $data['pages'] .'", "'. $data['pagesid'] .'", "'. $data['posts'] .'", "'. $data['postsid'] .'",
                                    "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'"
                                )';
                            }
                            $this->db->query($q2);
                        }
                    }

                    $q3 = 'DROP TABLE `'. $this->tableDrop .'_backup_2`';
                    $this->db->query($q3);
                }
            }
            else {
                if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableDrop .'_backup"') == $this->tableDrop .'_backup') {
                    $q = 'CREATE TABLE `'. $this->tableDrop .'` LIKE `'. $this->tableDrop .'_backup`';
                    $this->db->query($q);

                    $q2 = 'INSERT INTO `'. $this->tableDrop .'` SELECT * FROM `'. $this->tableDrop .'_backup`';
                    $this->db->query($q2);

                    $q3 = 'DROP TABLE `'. $this->tableDrop .'_backup`';
                    $this->db->query($q3);
                }
            }
            update_option($this->tableDrop, $this->tableDrop_version);
		}

	function uninstall() {
		$this->_uninstallTableImpressions();
		$this->_uninstallTableData();
		$this->_uninstallTableDrop();
	}

		function _uninstallTableImpressions() {
			if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableImpressions .'_backup"') != $this->tableImpressions .'_backup') {
                $q = 'CREATE TABLE `'. $this->tableImpressions .'_backup` LIKE `'. $this->tableImpressions .'`';
                $this->db->query($q);

                $q2 = 'INSERT INTO `'. $this->tableImpressions .'_backup` SELECT * FROM `'. $this->tableImpressions .'`';
                $this->db->query($q2);

                $q3 = 'DROP TABLE `'. $this->tableImpressions .'`';
                $this->db->query($q3);
            }
		}

		function _uninstallTableData() {
			if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableData .'_backup"') != $this->tableData .'_backup') {
                $q = 'CREATE TABLE `'. $this->tableData .'_backup` LIKE `'. $this->tableData .'`';
                $this->db->query($q);

                $q2 = 'INSERT INTO `'. $this->tableData .'_backup` SELECT * FROM `'. $this->tableData .'`';
                $this->db->query($q2);

                $q3 = 'DROP TABLE `'. $this->tableData .'`';
                $this->db->query($q3);
            }
		}

		function _uninstallTableDrop() {
			if ($this->db->get_var('SHOW TABLES LIKE "'. $this->tableDrop .'_backup"') != $this->tableDrop .'_backup') {
                $q = 'CREATE TABLE `'. $this->tableDrop .'_backup` LIKE `'. $this->tableDrop .'`';
                $this->db->query($q);

                $q2 = 'INSERT INTO `'. $this->tableDrop .'_backup` SELECT * FROM `'. $this->tableDrop .'`';
                $this->db->query($q2);

                $q3 = 'DROP TABLE `'. $this->tableDrop .'`';
                $this->db->query($q3);
            }
		}



	function getAllDrops() {
		$q = 'SELECT * FROM `'. $this->tableDrop .'` ORDER BY `dropid` DESC';
		return $this->db->get_results($q, ARRAY_A);
	}

	function getDropById($dropid) {
		$q = 'SELECT * FROM `'. $this->tableDrop .'` WHERE `dropid`='. intval($dropid);
		return $this->db->get_row($q, ARRAY_A);
	}

	function getDropsByStatus($status) {
		$q = 'SELECT * FROM `'. $this->tableDrop .'` WHERE `status`='. intval($status);
		return $this->db->get_results($q, ARRAY_A);
	}

	function addDrop() {
		if ($_POST) {
			$name       = trim(strip_tags($_POST['name']));

			$title      = trim(strip_tags($_POST['title']));
			$clicks     = 0;

			$homepage   = (trim(strip_tags($_POST['homepage'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pages      = (trim(strip_tags($_POST['pages'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pagesid    = str_replace(', ', ',', trim(strip_tags($_POST['pagesid'])));
			$posts      = (trim(strip_tags($_POST['posts'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$postsid    = str_replace(', ', ',', trim(strip_tags($_POST['postsid'])));

			$created    = strftime('%Y-%m-%d %T');
			$modified   = strftime('%Y-%m-%d %T');
			$ip         = $_SERVER['REMOTE_ADDR'];
			$status     = SBP_ENABLED;

			$q = 'INSERT INTO `'. $this->tableDrop .'` (
				`dropid`, `name`,
				`title`, `clicks`,
				`homepage`, `pages`, `pagesid`, `posts`, `postsid`,
				`created`, `modified`, `ip`, `status`
			) VALUES (
				NULL, "'. $name .'",
				"'. $title .'", "'. $clicks .'",
				"'. $homepage .'", "'. $pages .'", "'. $pagesid .'", "'. $posts .'", "'. $postsid .'",
				"'. $created .'", "'. $modified .'", "'. $ip .'", "'. $status .'"
			)';
			$this->db->query($q);
			$dropid = $this->db->insert_id;


			for ($d = 1; $d <= $this->tableDropMaxCount; $d++) {
				$name       = trim(strip_tags($_POST['description'. $d]));
				$url        = trim(strip_tags($_POST['url'. $d]));
				$clicks     = 0;

				$created    = strftime('%Y-%m-%d %T');
				$modified   = strftime('%Y-%m-%d %T');
				$ip         = $_SERVER['REMOTE_ADDR'];
				$status     = SBP_ENABLED;

				$q2 = 'INSERT INTO `'. $this->tableData .'` (
					`dataid`, `dropid`,
					`name`, `url`, `clicks`,
					`created` ,`modified`, `ip`, `status`
				) VALUES (
					NULL, "'. $dropid .'",
					"'. $name .'", "'. $url .'", "'. $clicks .'",
					"'. $created .'", "'. $modified .'", "'. $ip .'", "'. $status .'"
				)';
				$this->db->query($q2);
			}

			$q3 = 'DELETE FROM `'. $this->tableData .'` WHERE `name`="" AND `url`=""';
			$this->db->query($q3);


			$styles = get_option($this->tableStyles .'_'. $dropid);
			if (!is_array($styles) || is_array($styles)) {
				$data = array(
					'shortcode_select_width'    => trim(strip_tags($_POST['sSelectWidth'])),
					'shortcode_select_padding'  => trim(strip_tags($_POST['sSelectPadding'])),
					'shortcode_select_border'   => trim(strip_tags($_POST['sSelectBorder'])),
					'shortcode_select_fontsize' => trim(strip_tags($_POST['sSelectFontsize'])),

					'widget_select_width'       => trim(strip_tags($_POST['wSelectWidth'])),
					'widget_select_padding'     => trim(strip_tags($_POST['wSelectPadding'])),
					'widget_select_border'      => trim(strip_tags($_POST['wSelectBorder'])),
					'widget_select_fontsize'    => trim(strip_tags($_POST['wSelectFontsize']))
				);
				update_option($this->tableStyles .'_'. $dropid, $data);
			}

			die ('done');
		}
		die ('error');
	}

	function deleteDrop() {
		if ($_POST) {
			$dropid = intval($_POST['id']);

			$q = 'DELETE FROM `'. $this->tableDrop .'` WHERE `dropid`='. intval($dropid);
			$this->db->query($q);

			$q2 = 'DELETE FROM `'. $this->tableImpressions .'` WHERE `dropid`='. intval($dropid);
			$this->db->query($q2);

			delete_option($this->tableStyles .'_'. $dropid);

			die ('done');
		}
		die ('error');
	}

	function updateDropStatus() {
		if ($_POST) {
			$dropid = intval($_POST['id']);
			$drop   = $this->getDropById($dropid);
			if (0 != count($drop)) {
				$status = ($drop['status'] == SBP_ENABLED) ? SBP_DISABLED : SBP_ENABLED;

				$q = 'UPDATE `'. $this->tableDrop .'` SET `status`='. intval($status) .' WHERE `dropid`='. intval($dropid);
				$this->db->query($q);
			}
			die ('done');
		}
		die ('error');
	}

	function resetAllStats() {
		if ($_POST) {
			$clicks = 0;

			$q = 'UPDATE `'. $this->tableDrop .'` SET `clicks`='. intval($clicks);
			$this->db->query($q);

			$q2 = 'UPDATE `'. $this->tableData .'` SET `clicks`='. intval($clicks);
			$this->db->query($q2);

			$q3 = 'DELETE FROM `'. $this->tableImpressions .'`';
			$this->db->query($q3);

			die ('done');
		}
		die ('error');
	}

	function resetStats() {
		if ($_POST) {
			$dropid = intval($_POST['id']);

			$clicks = 0;

			$q = 'UPDATE `'. $this->tableDrop .'` SET `clicks`='. intval($clicks) .' WHERE `dropid`='. intval($dropid);
			$this->db->query($q);

			$q2 = 'UPDATE `'. $this->tableData .'` SET `clicks`='. intval($clicks) .' WHERE `dropid`='. intval($dropid);
			$this->db->query($q2);

			$q3 = 'DELETE FROM `'. $this->tableImpressions .'` WHERE `dropid`='. intval($dropid);
			$this->db->query($q3);

			die ('done');
		}
		die ('error');
	}

	function getDataByDropid($dropid) {
		$q = 'SELECT * FROM `'. $this->tableData .'` WHERE `dropid`='. intval($dropid);
		return $this->db->get_results($q, ARRAY_A);
	}

	function getDataById($dataid) {
		$q = 'SELECT * FROM `'. $this->tableData .'` WHERE `dataid`='. intval($dataid);
		return $this->db->get_row($q, ARRAY_A);
	}

	function updateDrop() {
		if ($_POST) {
			$dropid     = intval($_POST['id']);
			$name       = trim(strip_tags($_POST['name']));

			$title      = trim(strip_tags($_POST['title']));

			$homepage   = (trim(strip_tags($_POST['homepage'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pages      = (trim(strip_tags($_POST['pages'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$pagesid    = str_replace(', ', ',', trim(strip_tags($_POST['pagesid'])));
			$posts      = (trim(strip_tags($_POST['posts'])) == 'true') ? SBP_ENABLED : SBP_DISABLED;
			$postsid    = str_replace(', ', ',', trim(strip_tags($_POST['postsid'])));

			$modified   = strftime('%Y-%m-%d %T');
			$ip         = $_SERVER['REMOTE_ADDR'];

			$q = 'UPDATE `'. $this->tableDrop .'` SET
				`name`="'. $name .'",
				`title`="'. $title .'",
				`homepage`="'. $homepage .'", `pages`="'. $pages .'", `pagesid`="'. $pagesid .'", `posts`="'. $posts .'", `postsid`="'. $postsid .'",
				`modified`="'. $modified .'", `ip`="'. $ip .'" WHERE `dropid`='. intval($dropid);
			$this->db->query($q);


			$q2 = 'DELETE FROM `'. $this->tableData .'` WHERE `dropid`='. intval($dropid);
			$this->db->query($q2);

			for ($d = 1; $d <= $this->tableDropMaxCount; $d++) {
				$name       = trim(strip_tags($_POST['description'. $d]));
				$url        = trim(strip_tags($_POST['url'. $d]));
				$clicks     = 0;

				$created    = strftime('%Y-%m-%d %T');
				$modified   = strftime('%Y-%m-%d %T');
				$ip         = $_SERVER['REMOTE_ADDR'];
				$status     = SBP_ENABLED;

				$q3 = 'INSERT INTO `'. $this->tableData .'` (
					`dataid`, `dropid`,
					`name`, `url`, `clicks`,
					`created` ,`modified`, `ip`, `status`
				) VALUES (
					NULL, "'. $dropid .'",
					"'. $name .'", "'. $url .'", "'. $clicks .'",
					"'. $created .'", "'. $modified .'", "'. $ip .'", "'. $status .'"
				)';
				$this->db->query($q3);
			}

			$q4 = 'DELETE FROM `'. $this->tableData .'` WHERE `name`="" AND `url`=""';
			$this->db->query($q4);


			$styles = get_option($this->tableStyles .'_'. $dropid);
			if (!is_array($styles) || is_array($styles)) {
				$data = array(
					'shortcode_select_width'    => trim(strip_tags($_POST['sSelectWidth'])),
					'shortcode_select_padding'  => trim(strip_tags($_POST['sSelectPadding'])),
					'shortcode_select_border'   => trim(strip_tags($_POST['sSelectBorder'])),
					'shortcode_select_fontsize' => trim(strip_tags($_POST['sSelectFontsize'])),

					'widget_select_width'       => trim(strip_tags($_POST['wSelectWidth'])),
					'widget_select_padding'     => trim(strip_tags($_POST['wSelectPadding'])),
					'widget_select_border'      => trim(strip_tags($_POST['wSelectBorder'])),
					'widget_select_fontsize'    => trim(strip_tags($_POST['wSelectFontsize']))
				);
				update_option($this->tableStyles .'_'. $dropid, $data);
			}

			die ('done');
		}
		die ('erorr');
	}

	function addImpression($data) {
		$q = 'INSERT INTO `'. $this->tableImpressions .'` (`impressionsid`, `dropid`, `dataid`, `created`, `modified`, `ip`, `status`) VALUES (NULL, "'. $data['dropid'] .'", "'. $data['dataid'] .'", "'. $data['created'] .'", "'. $data['modified'] .'", "'. $data['ip'] .'", "'. $data['status'] .'")';
		$this->db->query($q);
	}

	function updateDropClicks() {
		if ($_POST ) {
			$dropid = intval($_POST['id']);
			$drop   = $this->getDropById($dropid);
			if (0 != count($drop)) {
				$clicks = $drop['clicks'] + 1;

				$q = 'UPDATE `'. $this->tableDrop .'` SET `clicks`='. intval($clicks) .' WHERE `dropid`='. intval($dropid);
				$this->db->query($q);
			}

			die ('done');
		}
		die ('error');
	}

	function updateDataClicks() {
		if ($_POST) {
			$dataid = intval($_POST['id']);
			$data   = $this->getDataById($dataid);
			if (0 != count($data)) {
				$dropid = $data['dropid'];
				$clicks = $data['clicks'] + 1;

				$q = 'UPDATE `'. $this->tableData .'` SET `clicks`='. intval($clicks) .' WHERE `dataid`='. intval($dataid);
				$this->db->query($q);


				$drop = array(
					'dropid'    => $dropid,
					'dataid'    => $dataid,
					'created'   => strftime('%Y-%m-%d %T'),
					'modified'  => strftime('%Y-%m-%d %T'),
					'ip'        => $_SERVER['REMOTE_ADDR'],
					'status'    => SBP_ENABLED
				);
				$q2 = 'INSERT INTO `'. $this->tableImpressions .'` (`impressionsid`, `dropid`, `dataid`, `created`, `modified`, `ip`, `status`) VALUES (NULL, "'. $drop['dropid'] .'", "'. $drop['dataid'] .'", "'. $drop['created'] .'", "'. $drop['modified'] .'", "'. $drop['ip'] .'", "'. $drop['status'] .'")';
				$this->db->query($q2);
			}

			die ('done');
		}
		die ('error');
	}

	function sumAllDataClicksByDropid($dropid) {
		$q = 'SELECT SUM(`clicks`) AS `clicks` FROM `'. $this->tableData .'` WHERE `dropid`='. intval($dropid);
		return $this->db->get_var($q);
	}

	function countAllDropImpressionsByDropid($dropid) {
		$q = 'SELECT COUNT(*) FROM `'. $this->tableImpressions .'` WHERE `dropid`='. intval($dropid) .' AND `dataid`=""';
		return $this->db->get_var($q);
	}
}