<?php
/**
 * Filename: _widgets_customsearch.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

class sbpWidgetsCustomsearch extends WP_Widget {
	function init() {
		register_widget('sbpWidgetsCustomsearch');
	}

	function sbpWidgetsCustomsearch() {
		$options = array(
			'classname'     => 'sbpWidgetsCustomsearch',
			'description'   => SBP_NAME .' - Custom Search is an awesome widget'
		);

		$controls = array(
			'width'     => 350,
			'height'    => 350,
			'id_base'   => SBP_CODE .'-widgets-customsearch'
		);

		parent::__construct(SBP_CODE .'-widgets-customsearch', 'Custom Search 2', $options, $controls);
	}

	function update($new, $old) {
		$instance = array();
		return $instance;
	}

	function form($instance) {
		echo '<p>Please <a href="'. admin_url('admin.php?page='. SBP_CODE) .'">click me</a> to go to the configuration area of this widget.</p>';
	}

	function widget($args, $instance) {
		global $sbpDatabaseCustomsearch,
		       $post;

		$getEnabledCs = $sbpDatabaseCustomsearch->getCustomsearchByStatus(SBP_ENABLED);
		if (0 != count($getEnabledCs)) {
			foreach ($getEnabledCs as $cs) {

				$homepage   = $cs['homepage'];
				$pages      = $cs['pages'];
				$pagesid    = $cs['pagesid'];
				$posts      = $cs['posts'];
				$postsid    = $cs['postsid'];

				//* homepage
				if (is_home() || is_front_page() || is_sticky()) {
					if ($homepage == SBP_ENABLED) {
						$this->content($args, $instance, $cs);
					}
				}

				//* pages
				if (is_page()) {
					if ($pages == SBP_ENABLED) {
						if (0 != strlen($pagesid)) {
							if (in_array($post->ID, explode(',', $pagesid))) {
								$this->content($args, $instance, $cs);
							}
						}
						else {
							$this->content($args, $instance, $cs);
						}
					}
				}

				//* posts
				if (is_single()) {
					if ($posts == SBP_ENABLED) {
						if (0 != strlen($postsid)) {
							if (in_array($post->ID, explode(',', $postsid))) {
								$this->content($args, $instance, $cs);
							}
						}
						else {
							$this->content($args, $instance, $cs);
						}
					}
				}

			}
		}
	}

	function content($args, $instance, $cs) {
		global $sbpDatabaseCustomsearch;

		$csid   = intval($cs['csid']);
		$styles = get_option($sbpDatabaseCustomsearch->tableCsStyles .'_'. $csid);

		$txtbox_width       = (0 != strlen($styles['widget_txtbox_width'])) ? 'size="'. $styles['widget_txtbox_width'] .'"' : '';
		$txtbox_padding     = (0 != strlen($styles['widget_txtbox_padding'])) ? 'padding:'. $styles['widget_txtbox_padding'] .'!important;' : '';
		$txtbox_border      = (0 != strlen($styles['widget_txtbox_border'])) ? 'border:'. $styles['widget_txtbox_border'] .'!important;' : '';
		$txtbox_fontsize    = (0 != strlen($styles['widget_txtbox_fontsize'])) ? 'font-size:'. $styles['widget_txtbox_fontsize'] .'!important;' : '';

		$btn                = (0 != strlen($styles['btn'])) ? $styles['btn'] : 'Search';
		$btn_bg             = (0 != strlen($styles['btn_bg'])) ? 'background:'. $styles['btn_bg'] .'!important;' : '';
		$btn_padding        = (0 != strlen($styles['btn_padding'])) ? 'padding:'. $styles['btn_padding'] .'!important;' : '';
		$btn_color          = (0 != strlen($styles['btn_color'])) ? 'color:'. $styles['btn_color'] .'!important;' : '';


		//* add impression
		$impression = array(
			'csid'      => $csid,
			'created'   => strftime('%Y-%m-%d %T'),
			'modified'  => strftime('%Y-%m-%d %T'),
			'ip'        => $_SERVER['REMOTE_ADDR'],
			'status'    => SBP_ENABLED
		);
		$sbpDatabaseCustomsearch->addImpression($impression);


		echo $before_widget;
			echo $before_title;
			echo $after_title;
			?>


		<form name="wCsForm<?php echo $csid; ?>" id="wCsForm<?php echo $csid; ?>" method="POST" action="">
			<input type="hidden" name="cs-w-url" id="cs-w-url" value="<?php echo $cs['url']; ?>" />

			<div align="center">
				<?php echo (0 != strlen($cs['content'])) ? str_replace('\\', '', $cs['content']) : ''; ?>

				<input type="text" name="cs-w-term" id="cs-w-term" <?php echo $txtbox_width; ?> style="<?php echo $txtbox_padding . $txtbox_border . $txtbox_fontsize; ?>" />
				<br /><br />
				<input type="submit" name="cmdSubmitCsWidget" id="cmdSubmitCsWidget" value="<?php echo $btn; ?>" style="<?php echo $btn_bg . $btn_padding . $btn_color; ?>" />

				<?php echo (0 != strlen($cs['privacy']) ? str_replace('\\', '', $cs['privacy']) : ''); ?>
			</div>
		</form> <br />


		<script type="text/javascript">
			var sbpCsWidget<?php echo $csid; ?> = jQuery.noConflict();
			sbpCsWidget<?php echo $csid; ?>(function($) {
				$('#wCsForm<?php echo $csid; ?>').submit(function(event) {
					event.preventDefault();

					var $this           = $(this),
						$fields         = {}
						$fieldsArray    = $this.serializeArray();

					$.each($fieldsArray, function(index, field) {
						$fields[field.name] = field.value;
					});

					var $url    = $fields['cs-w-url'],
						$term   = $fields['cs-w-term'];

					if ($term == '') {
						alert('Cannot submit blank form');
						return false;
					}

					var $data = {
						action  : 'sbp_cs_clicks',
						id      : <?php echo $csid; ?>
					}
					$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data, function(res) {
						if (res != 0) {
							var replaceUrlTerm = $url.replace('<?php echo $cs['term']; ?>', $term);
							window.open(replaceUrlTerm);
						}
					});
				});
			});
		</script>



			<?php
		echo $after_widget;
	}
}