<?php
/**
 * Filename: _widgets_squeeze.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

class sbpWidgetsSqueeze extends WP_Widget {
	function init() {
		register_widget('sbpWidgetsSqueeze');
	}

	function sbpWidgetsSqueeze() {
		$options = array(
			'classname'     => 'sbpWidgetsSqueeze',
			'description'   => SBP_NAME .' is an awesome widget'
		);

		$controls = array(
			'width'     => 350,
			'height'    => 350,
			'id_base'   => SBP_CODE .'-widgets-squeeze'
		);

		parent::__construct(SBP_CODE .'-widgets-squeeze', SBP_NAME, $options, $controls);
	}

	function update($new, $old) {
		$instance = array();
		return $instance;
	}

	function form($instance) {
		echo '<p>Please <a href="'. admin_url('admin.php?page='. SBP_CODE) .'">click me</a> to go to the configuration area of this widget.</p>';
	}

	function widget($args, $instance) {
		global $sbpDatabaseSqueeze,
		       $post;


		$optinsName     = $sbpDatabaseSqueeze->tableOptins;
		$optinsCount    = $sbpDatabaseSqueeze->tableOptinsCount;

		$affiliates     = get_option($sbpDatabaseSqueeze->tableAffiliates);
		$adsense        = get_option($sbpDatabaseSqueeze->tableAdsense);
		$thankyou       = get_option($sbpDatabaseSqueeze->tableThankyou);
		$sales          = get_option($sbpDatabaseSqueeze->tableSales);
		$recentComments = get_option($sbpDatabaseSqueeze->tableRecentComments);
		$recentPosts    = get_option($sbpDatabaseSqueeze->tableRecentPosts);



		//* homepage
		if (is_home() || is_sticky() || is_front_page()) {
			if ($affiliates['homepage'] == SBP_ENABLED) {
				$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $affiliates);
			}

			if ($adsense['homepage'] == SBP_ENABLED) {
				$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $adsense);
			}

			if ($thankyou['homepage'] == SBP_ENABLED) {
				$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $thankyou);
			}

			if ($sales['homepage'] == SBP_ENABLED) {
				$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $sales);
			}

			if ($recentComments['homepage'] == SBP_ENABLED) {
				$this->templateForRecentComments($args, $instance, $recentComments);
			}

			if ($recentPosts['homepage'] == SBP_ENABLED) {
				$this->templateForRecentPosts($args, $instance, $recentPosts);
			}
		}

		//* pages
		if (is_page()) {
			if ($affiliates['pages'] == SBP_ENABLED) {
				if (0 != strlen($affiliates['pagesid'])) {
					if (in_array($post->ID, explode(',', $affiliates['pagesid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $affiliates);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $affiliates);
				}
			}

			if ($adsense['pages'] == SBP_ENABLED) {
				if (0 != strlen($adsense['pagesid'])) {
					if (in_array($post->ID, explode(',', $adsense['pagesid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $adsense);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $adsense);
				}
			}


			if ($thankyou['pages'] == SBP_ENABLED) {
				if (0 != strlen($thankyou['pagesid'])) {
					if (in_array($post->ID, explode(',', $thankyou['pagesid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $thankyou);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $thankyou);
				}
			}

			if ($sales['pages'] == SBP_ENABLED) {
				if (0 != strlen($sales['pagesid'])) {
					if (in_array($post->ID, explode(',', $sales['pagesid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $sales);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $sales);
				}
			}

			if ($recentComments['pages'] == SBP_ENABLED) {
				if (0 != strlen($recentComments['pagesid'])) {
					if (in_array($post->ID, explode(',', $recentComments['pagesid']))) {
						$this->templateForRecentComments($args, $instance, $recentComments);
					}
				}
				else {
					$this->templateForRecentComments($args, $instance, $recentComments);
				}
			}

			if ($recentPosts['pages'] == SBP_ENABLED) {
				if (0 != strlen($recentPosts['pagesid'])) {
					if (in_array($post->ID, explode(',', $recentPosts['pagesid']))) {
						$this->templateForRecentPosts($args, $instance, $recentPosts);
					}
				}
				else {
					$this->templateForRecentPosts($args, $instance, $recentPosts);
				}
			}
		}

		//* posts
		if (is_single()) {
			if ($affiliates['posts'] == SBP_ENABLED) {
				if (0 != strlen($affiliates['postsid'])) {
					if (in_array($post->ID, explode(',', $affiliates['postsid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $affiliates);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $affiliates);
				}
			}

			if ($adsense['posts'] == SBP_ENABLED) {
				if (0 != strlen($adsense['postsid'])) {
					if (in_array($post->ID, explode(',', $adsense['postsid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $adsense);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $adsense);
				}
			}


			if ($thankyou['posts'] == SBP_ENABLED) {
				if (0 != strlen($thankyou['postsid'])) {
					if (in_array($post->ID, explode(',', $thankyou['postsid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $thankyou);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $thankyou);
				}
			}

			if ($sales['posts'] == SBP_ENABLED) {
				if (0 != strlen($sales['postsid'])) {
					if (in_array($post->ID, explode(',', $sales['postsid']))) {
						$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $sales);
					}
				}
				else {
					$this->templateForAffiliatesAdsenseThankyouSales($args, $instance, $sales);
				}
			}

			if ($recentComments['posts'] == SBP_ENABLED) {
				if (0 != strlen($recentComments['postsid'])) {
					if (in_array($post->ID, explode(',', $recentComments['postsid']))) {
						$this->templateForRecentComments($args, $instance, $recentComments);
					}
				}
				else {
					$this->templateForRecentComments($args, $instance, $recentComments);
				}
			}

			if ($recentPosts['posts'] == SBP_ENABLED) {
				if (0 != strlen($recentPosts['postsid'])) {
					if (in_array($post->ID, explode(',', $recentPosts['postsid']))) {
						$this->templateForRecentPosts($args, $instance, $recentPosts);
					}
				}
				else {
					$this->templateForRecentPosts($args, $instance, $recentPosts);
				}
			}
		}





		//* optins
		for ($o = 1; $o <= $optinsCount; $o++) {
			$options = get_option($optinsName .'_'. $o);

			$homepage   = $options['homepage'];
			$pages      = $options['pages'];
			$pagesid    = $options['pagesid'];
			$posts      = $options['posts'];
			$postsid    = $options['postsid'];

			//* homepage
			if (is_home() || is_front_page() || is_sticky()) {
				if ($homepage == SBP_ENABLED) {
					$this->templateForOptins($o, $args, $instance, $options);
				}
			}

			//* pages
			if (is_page()) {
				if ($pages == SBP_ENABLED) {
					if (0 != strlen($pagesid)) {
						if (in_array($post->ID, explode(',', $pagesid))) {
							$this->templateForOptins($o, $args, $instance, $options);
						}
					}
					else {
						$this->templateForOptins($o, $args, $instance, $options);
					}
				}
			}

			//* posts
			if (is_single()) {
				if ($posts == SBP_ENABLED) {
					if (0 != strlen($postsid)) {
						if (in_array($post->ID, explode(',', $postsid))) {
							$this->templateForOptins($o, $args, $instance, $options);
						}
					}
					else {
						$this->templateForOptins($o, $args, $instance, $options);
					}
				}
			}
		}

	}



	//* template for optins
	function templateForOptins($index, $args, $instance, $options) {
		extract ($args);
		?>


		<style type="text/css">
			.sbp-<?php echo $index; ?> {
				margin: 0 !important;
				padding: 5px !important;
				background: <?php echo $options['theme_main_bg']; ?> !important;
				border: 3px solid <?php echo $options['theme_main_border_color']; ?> !important;
				border-radius: 5px !important;
					-moz-border-radius: 5px !important;
					-webkit-border-radius: 5px !important;
			}

			.sbp-<?php echo $index; ?> .bullets ul {
				padding: 0 !important;
				margin: 0 !important;
				list-style-type: none !important;
			}

				.sbp-<?php echo $index; ?> .bullets ul li::before {
					display:none !important;
				}

				.sbp-<?php echo $index; ?> .bullets ul li {
					background: url(<?php echo SBP_URL .'tmpl/images/check.png'; ?>) no-repeat !important;
					background-position: 0 0.2em !important;
					margin-left: 10px !important;
					padding-left: 20px !important;
					padding-bottom: 5px !important;

					color: #000 !important;
				}

			.sbp-<?php echo $index; ?> .optin {
				text-align: center !important;
			}

				.sbp-<?php echo $index; ?> .optin .headline {
					color: <?php echo $options['theme_headline_color']; ?> !important;
					font-weight: <?php echo $options['theme_headline_bold']; ?> !important;
					padding: 10px !important;
				}

				.sbp-<?php echo $index; ?> .optin input[type="text"] {
					width: <?php echo $options['theme_txtbox_width']; ?> !important;
					margin: 5px !important;
					padding: 10px !important;
					border: 2px solid <?php echo $options['theme_txtbox_border_color']; ?> !important;

					font-size: <?php echo $options['theme_txtbox_fontsize']; ?> !important;
				}

				.sbp-<?php echo $index; ?> .optin input[type="submit"] {
					padding: 10px !important;
					margin: 0 auto !important;
					margin-top: 15px !important;
					background: <?php echo $options['theme_btn_bg']; ?> !important;
					border: 2px solid <?php echo $options['theme_btn_border_color']; ?> !important;
					border-radius: 5px !important;
						-moz-border-radius: 5px !important;
						-webkit-border-radius: 5px !important;

					font-weight: <?php echo $options['theme_btn_bold']; ?> !important;
					font-size: <?php echo $options['theme_btn_fontsize']; ?> !important;
					color: <?php echo $options['theme_btn_color']; ?> !important;
				}

			.sbp-<?php echo $index; ?> .privacy p {
				text-align: center !important;
				padding-top: 10px !important;
				font-size: 10px !important;
				color: #8c8089 !important;
			}
		</style>



		<?php
		echo $before_widget;
			echo $before_title;
				echo ($options['title_hide'] == SBP_DISABLED) ? $options['title'] : '';
			echo $after_title;
			?>


			<div class="sbp-<?php echo $index; ?>">

				<?php
				if (0 != strlen($options['contents'])) {
					echo '<div class="content">';
						echo str_replace('\\', '', $options['contents']);
					echo '</div>';
				}
				?>



				<?php if ($options['is_aweber'] == SBP_YES) { ?>

					<div class="bullets">
						<?php
						if (0 != strlen($options['aweber_bullet_1']) || 0 != strlen($options['aweber_bullet_2']) || 0 != strlen($options['aweber_bullet_3'])) {
							echo '<ul>';
							echo (0 != strlen($options['aweber_bullet_1'])) ? '<li>' . $options['aweber_bullet_1'] . '</li>' : '';
							echo (0 != strlen($options['aweber_bullet_2'])) ? '<li>' . $options['aweber_bullet_2'] . '</li>' : '';
							echo (0 != strlen($options['aweber_bullet_3'])) ? '<li>' . $options['aweber_bullet_3'] . '</li>' : '';
							echo '</ul>';
						}
						?>
					</div> <br/>


					<form method="POST" action="http://www.aweber.com/scripts/addlead.pl">
						<input type="hidden" name="meta_web_form_id" value="1256636276"/>
						<input type="hidden" name="meta_split_id" value=""/>
						<input type="hidden" name="listname" value="<?php echo $options['listname']; ?>"/>
						<input type="hidden" name="redirect" value="<?php echo $options['thankyou']; ?>"
						       id="redirect_b221c6e90cbf15aa8cb43244834d4891"/>
						<input type="hidden" name="meta_redirect_onlist" value="<?php echo $options['thankyou']; ?>"/>
						<input type="hidden" name="meta_adtracking" value="My_Web_Form"/>
						<input type="hidden" name="meta_message" value="1"/>
						<input type="hidden" name="meta_required" value="name,email"/>
						<input type="hidden" name="meta_forward_vars" value=""/>
						<input type="hidden" name="meta_tooltip" value=""/>


						<div class="optin">
							<div class="headline">Fill in the form Below:</div>

							<input type="text" name="name" id="name" placeholder="Enter name..."/> <br/>
							<input type="text" name="email" id="email" placeholder="Enter email address..."/>

							<?php
							if ($options['theme_btn_img'] == 'yes') {
								echo '<input type="image" id="submit_image_5f17aab77d6c" width="' . $options['theme_btn_img_size'] . '" src="' . $options['theme_btn_img_src'] . '" />';
							} else {
								echo '<input type="submit" id="submit_image_5f17aab77d6c" value="' . $options['theme_btn_value'] . '" />';
							}
							?>
						</div>


						<?php
						if (0 != strlen($options['privacy'])) {
							echo '<div class="privacy">';
							echo str_replace('\\', '', $options['privacy']);
							echo '</div>';
						} else {
							echo '<div class="privacy" style="font-size:12px; text-align:center;"><a href="http://www.aweber.com/permission.html" target="_blank">Privacy</a></div>';
						}
						?>
					</form>


				<?php
				}
				else {
					echo str_replace('\\', '', $options['not_aweber_contents']);
				}
				?>

			</div>


			<?php
		echo $after_widget;
	}

	/**
	 * Template for
	 * * Affiliates
	 * * Adsense
	 * * Thank you
	 * * Sales
	 */
	function templateForAffiliatesAdsenseThankyouSales($args, $instance, $options) {
		extract ($args);

		echo $before_widget;
			echo $before_title;
				echo ($options['title_hide'] == SBP_DISABLED) ? $options['title'] : '';
			echo $after_title;

			echo (0 != strlen($options['contents'])) ? str_replace('\\', '', $options['contents']) : '';
		echo $after_widget;
	}

	//* tempalte for recent comments
	function templateForRecentComments($args, $instance, $options) {
		extract ($args);
		global $post;

		echo $before_widget;
			echo $before_title;
				echo ($options['title_hide'] == SBP_DISABLED) ? $options['title'] : '';
			echo $after_title;

			echo (0 != strlen($options['contents'])) ? str_replace('\\', '', $options['contents']) : '';

			if (0 != strlen($options['how_many'])) {
				$q = array(
					'status'    => 'approve',
					'number'    => $options['how_many']
				);
				$comments = get_comments($q);

				echo '<ul>';
					foreach ($comments as $comment) {
						echo '<li>' . $comment->comment_author .' on <a href="'. get_comment_link($comment->comment_ID) .'" title="' . comment_excerpt() .'">' . get_the_title($comment->comment_post_ID) . '</a></li>';
					}
				echo '</ul>';
			}

		echo $after_widget;
		wp_reset_query();
	}

	//* template for reent posts
	function templateForRecentPosts($args, $instance, $options) {
		extract ($args);
		global $post;

		echo $before_widget;
			echo $before_title;
				echo ($options['title_hide'] == SBP_DISABLED) ? $options['title'] : '';
			echo $after_title;

			echo (0 != strlen($options['contents'])) ? str_replace('\\', '', $options['contents']) : '';

			if (0 != $options['how_many']) {
				query_posts('showposts='. $options['how_many']);
				if (have_posts()) {
					echo '<ul>';
                        while (have_posts()) : the_post();
                            ?>

                            <li><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></li>

                            <?php
                        endwhile;
                    echo '</ul>';
				}
			}
		echo $after_widget;
		wp_reset_query();
	}
}