<?php
/**
 * Filename: manage-cs.part.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

global $sbpDatabaseCustomsearch;

$csOptions  = get_option($sbpDatabaseCustomsearch->tableCsOptions);
$getAllCs   = $sbpDatabaseCustomsearch->getAllCustomsearch();
?>


			<div>
				<div id="holder-manage-cs">
					<div class="ui-tabs-sub">
						<ul>
							<li><a href="#cs-manage">Manage</a></li>
							<li><a href="#cs-configuration">Configuration</a></li>
						</ul>
						
						
						<!-- manage -->
						<div id="cs-manage">

							<!-- holder manage -->
							<div id="holder-cs-manage">
								<div class="row cell">
									<h3>Manage
										<span style="float:right;">
											<span data-role="hint" data-hint-position="left" data-hint="New Custom Search">
												<a href="javascript:void(0);" name="cmdAddNewCustomsearch" id="cmdAddNewCustomsearch" class="button button-primary">
													<span class="icon mif-plus"></span>
												</a>
											</span>

											<a href="javascript:void(0);" name="cmdResetCsAllStats" id="cmdResetCsAllStats" class="button button-secondary" title="Reset all stats">
												<span class="dashicons dashicons-update fg-red"></span>
											</a>
										</span>
									</h3> <hr />
								</div>

								<div class="row cell">
									<table id="data-tables" class="table striped hover border">
								        <thead>
								            <tr>
									            <th width="100" style="text-align:center;">ID</th>
									            <th width="300">Name</th>
									            <th width="300">Details</th>
									            <th width="300" style="text-align:center;">Actions</th>
								            </tr>
								        </thead>

										<?php
										if (0 != count($getAllCs)) {
											echo '<tbody>';
												foreach ($getAllCs as $cs) {
													$csid = $cs['csid'];

													$impressions = $sbpDatabaseCustomsearch->countImpressionsByCsid($csid);
													?>

													<tr>
														<td style="text-align:center;"><?php echo $csid; ?></td>
														<td><?php echo $cs['name']; ?></td>
														<td>

															<div class="row cells2">
																<div class="cell">Impressions</div>
																<div class="cell" id="cs-impressions-<?php echo $csid; ?>"><?php echo $impressions; ?></div>
															</div>

															<div class="row cells2">
																<div class="cell">Clicks</div>
																<div class="cell" id="cs-clicks-<?php echo $csid; ?>"><?php echo $cs['clicks']; ?></div>
															</div>

														</td>
														<td style="text-align:center;">
															<a href="javascript:void(0);" name="cmdCopyCsCode" id="cmdCopyCsCode" rel="<?php echo $csid; ?>" class="button button-secondary" title="Copy <?php echo $cs['name']; ?>'s shortcode">
																<span class="dashicons dashicons-share"></span>
															</a>

															<span style="margin-left:10px;">&nbsp;</span>
															<a href="javascript:void(0);" name="cmdResetCsStat" id="cmdResetCsStat" rel="<?php echo $csid; ?>" class="button button-secondary" title="Reset stats for <?php echo $cs['name']; ?>">
																<span class="dashicons dashicons-update fg-red"></span>
															</a>
															<a href="javascript:void(0);" name="cmdUpdateCsStatus" id="cmdUpdateCsStatus" rel="<?php echo $csid; ?>" class="button button-secondary" title="Update <?php echo $cs['name']; ?>">
																<span class="dashicons dashicons-visibility <?php echo ($cs['status'] == SBP_ENABLED) ? 'fg-green' : 'fg-red'; ?>"></span>
															</a>
															<a href="<?php echo admin_url('admin.php?page=' . SBP_CODE . '&action=edit-cs&id=' . $csid); ?>" class="button button-secondary" title="Edit <?php echo $cs['name']; ?>">
																<span class="dashicons dashicons-edit"></span>
															</a>
															<a href="javascript:void(0);" name="cmdDeleteCs" id="cmdDeleteCs" rel="<?php echo $csid; ?>" class="button button-secondary">
																<span class="dashicons dashicons-trash fg-red"></span>
															</a>
														</td>
													</tr>

													<?php
												}
											echo '</tbody>';
										}
										?>

									</table>
								</div>
							</div>
							<!-- // holder manage -->


							<!-- holder addnew -->
							<div id="holder-cs-addnew" style="display:none;">
								<form name="csAddNewForm" id="csAddNewForm" method="POST" action="">
									<div class="row cell">
										<h3>Add New</h3> <hr />
									</div>

									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-name">Name ( reference only )</label>
												<input type="text" name="cs-name" id="cs-name" placeholder="Enter name ( reference only )" value="" />
											</div>
										</div>
									</div>


									<!-- widgets -->
									<div class="row cells2">
										<div class="cell">
											<div>
												<label for="cs-homepage" class="input-control checkbox adjust-top">
													<input type="checkbox" name="cs-homepage" id="cs-homepage" />
													<span class="check"></span>
													<span class="caption">Homepage</span>
												</label>
											</div>

											<div>
												<label for="cs-pages" class="input-control checkbox adjust-top">
													<input type="checkbox" name="cs-pages" id="cs-pages" />
													<span class="check"></span>
													<span class="caption">Pages</span>
												</label>

												<div id="holder-cs-pagesid" class="input-control text" style="width:55%;">
													<input type="text" name="cs-pagesid" id="cs-pagesid" placeholder="Enter PagesID. Comma separated." value="" />
												</div>
											</div>

											<div>
												<label for="cs-posts" class="input-control checkbox adjust-top">
													<input type="checkbox" name="cs-posts" id="cs-posts" />
													<span class="check"></span>
													<span class="caption">Posts</span>
												</label>

												<div id="holder-cs-postsid" class="input-control text" style="margin-left:2px; width:55%;">
													<input type="text" name="cs-postsid" id="cs-postsid" placeholder="Enter PostsID. Comma separated." value="" />
												</div>
											</div>
										</div>
									</div> <br />
									<!-- // widgets -->


									<!-- contents -->
									<div class="row">
										<div class="cell">
											<label for="cs-contents">Contents</label>
											<?php wp_editor('<h1 style="text-align:center; color:#ff0000;">Get Instant Access</h1>', 'cs-contents', array(
												'textarea_name' => 'cs-contents',
												'textarea_rows' => 5,
												'wpautop'       => true,
												'media_buttons' => true
											)); ?>
										</div>
									</div>
									<!-- // contents -->


									<!-- form -->
									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-url">Form URL</label>
												<input type="text" name="cs-url" id="cs-url" placeholder="Enter Form URL ( https://google.com/?q=search_term )" value="https://google.com/?q=search_term" />
											</div>
										</div>
										
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-term">Search Term</label>
												<input type="text" name="cs-term" id="cs-term" placeholder="Enter search term" value="search_term" />
											</div>
										</div>
									</div>
									<!-- // form -->


									<!-- shortcode and configuration -->
									<div class="row cells2">
										<div class="cell">
											<div class="panel" data-role="panel">
												<div class="heading">
													<span class="title">Shortcode Configuration</span>
												</div>
											</div>
											<div class="content" style="padding:10px; background:#ccc;">
												<br />
												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-shortcode-txtbox-width">Textbox Width</label>
															<input type="text" name="cs-shortcode-txtbox-width" id="cs-shortcode-txtbox-width" placeholder="Enter textbox width" value="50%" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-shortcode-txtbox-padding">Textbox Padding</label>
															<input type="text" name="cs-shortcode-txtbox-padding" id="cs-shortcode-txtbox-padding" placeholder="Enter textbox padding" value="15px" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-shortcode-txtbox-border">Textbox Border & Color</label>
															<input type="text" name="cs-shortcode-txtbox-border" id="cs-shortcode-txtbox-border" placeholder="Enter textbox border & color" value="5px solid #ccc" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-shortcode-txtbox-fontsize">Font Size</label>
															<input type="text" name="cs-shortcode-txtbox-fontsize" id="cs-shortcode-txtbox-fontsize" placeholder="Enter font size" value="16px" />
														</div>
													</div>
												</div>
											</div>
										</div>

										<div class="cell">
											<div class="panel" data-role="panel">
												<div class="heading">
													<span class="title">Widget Configuration</span>
												</div>
											</div>
											<div class="content" style="padding:10px; background:#ccc;">
												<br />
												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-widget-txtbox-width">Textbox Width</label>
															<input type="text" name="cs-widget-txtbox-width" id="cs-widget-txtbox-width" placeholder="Enter textbox width" value="50%" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-widget-txtbox-padding">Textbox Padding</label>
															<input type="text" name="cs-widget-txtbox-padding" id="cs-widget-txtbox-padding" placeholder="Enter textbox padding" value="15px" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-widget-txtbox-border">Textbox Border & Color</label>
															<input type="text" name="cs-widget-txtbox-border" id="cs-widget-txtbox-border" placeholder="Enter textbox border & color" value="5px solid #ccc" />
														</div>
													</div>
												</div>

												<div class="row">
													<div class="cell">
														<div class="input-control text full-size">
															<label for="cs-widget-txtbox-fontsize">Font Size</label>
															<input type="text" name="cs-widget-txtbox-fontsize" id="cs-widget-txtbox-fontsize" placeholder="Enter font size" value="16px" />
														</div>
													</div>
												</div>
											</div>
										</div>
									</div> <br />
									<!-- // shortcode and configuration -->


									<!-- button -->
									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-btn">Button Name</label>
												<input type="text" name="cs-btn" id="cs-btn" placeholder="Enter button name" value="Search" />
											</div>
										</div>
									</div>
									
									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-btn-bg">Button Background</label>
												<input type="text" name="cs-btn-bg" id="cs-btn-bg" placeholer="Enter button background" value="#ccc" />
											</div>
										</div>
									</div>

									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-btn-padding">Button Padding</label>
												<input type="text" name="cs-btn-padding" id="cs-btn-padding" placeholder="Enter button padding" value="15px" />
											</div>
										</div>
									</div>

									<div class="row cells2">
										<div class="cell">
											<div class="input-control text full-size">
												<label for="cs-btn-color">Button Text Color</label>
												<input type="text" name="cs-btn-color" id="cs-btn-color" placeholder="Enter button text color" value="#00b53a" />
											</div>
										</div>
									</div>
									<!-- // button -->



									<br />
									<div class="row cells2">
										<div class="cell">
											<input type="submit" name="cmdSubmitNewCs" id="cmdSubmitNewCs" class="button button-primary" value="Save" />
											<a href="javascript:void(0);" name="cmdCancelNewCs" id="cmdCancelNewCs" class="button button-secondary fg-red">
												<span class="mif-cancel fg-red"></span> Cancel
											</a>
											<span id="dialog-cs-addnew"></span>
										</div>
									</div>
								</form>
							</div>
							<!-- // holder addnew -->

						</div>
						<!-- // manage -->
						
						
						<!-- configuration -->
						<div id="cs-configuration">
							<div class="row cell">
								<h3>Configuration</h3> <hr />
							</div>
							
							
							<form name="csConfigForm" id="csConfigForm" method="POST" action="">
								<div class="row">
									<div class="cell">
										<label for="cs-config-privacy">Privacy</label>
										<?php wp_editor($csOptions['privacy'], 'cs-config-privacy', array(
											'textarea_name' => 'cs-config-privacy',
											'textarea_rows' => 5,
											'wpautop'       => true,
											'media_buttons' => true
										)); ?>
									</div>
								</div> <br />

								<div class="row cells2">
									<div class="cell">
										<input type="submit" name="cmdSubmiCsConfig" id="cmdSubmitCsConfig" class="button button-primary" value="Update Configuration" />
										<span id="dialog-cs-config" style="margin-left:10px;"></span>
									</div>
								</div>
							</form>
						</div>
						<!-- // configuration -->
					</div>
				</div>
			</div>




			<script type="text/javascript">
				var sbpCs = jQuery.noConflict();
				sbpCs(function($) {

					//* config
					$('#cmdSubmitCsConfig').click(function() {
						var $privacy    = tinymceGetContent('cs-config-privacy', 'cs-config-privacy'),
							$dialog     = $('#dialog-cs-config'),

							$data       = {
								action  : 'sbp_cs_update_config',
								privacy : $privacy
							};


						$dialog.empty().append('Submitting data... Please wait!');
						$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data, function(result) {
							if (result != 'done') {
								$dialog.empty().append('Data cannot be processed. Please try again!');
							}
							else {
								$dialog.empty().append('Data has been successfully submitted.');
							}
						});

						return false;
					});


					//* add new
					$('#cmdAddNewCustomsearch').click(function() {
						$('#holder-cs-manage').slideUp();
						$('#holder-cs-addnew').slideDown();
						return false;
					});


					//* cancel new
					$('#cmdCancelNewCs').click(function() {
						$('#holder-cs-manage').slideDown();
						$('#holder-cs-addnew').slideUp();
						return false;
					});



					//* pages
					if ($('#cs-pages').is(':checked')) {
						$('#holder-cs-pagesid').slideDown();
					}
					else {
						$('#holder-cs-pagesid').slideUp();
					}

					$('#cs-pages').click(function() {
						var $this   = $(this),
							$holder = $('#holder-cs-pagesid');

						if ($this.is(':checked')) {
							$holder.slideDown();
						}
						else {
							$holder.slideUp();
						}
					});


					//* posts
					if ($('#cs-posts').is(':checked')) {
						$('#holder-cs-postsid').slideDown();
					}
					else {
						$('#holder-cs-postsid').slideUp();
					}

					$('#cs-posts').click(function() {
						var $this   = $(this),
							$holder = $('#holder-cs-postsid');

						if ($this.is(':checked')) {
							$holder.slideDown();
						}
						else {
							$holder.slideUp();
						}
					});


					//* submit
					$('#cmdSubmitNewCs').click(function() {
						var $name       = $('#cs-name'),

							$homepage   = $('#cs-homepage'),
							$pages      = $('#cs-pages'),
							$pagesid    = $('#cs-pagesid'),
							$posts      = $('#cs-posts'),
							$postsid    = $('#cs-postsid'),

							$contents   = tinymceGetContent('cs-contents', 'cs-contents'),

							$url        = $('#cs-url'),
							$term       = $('#cs-term'),

							$shortcodeTxtboxWidth = $('#cs-shortcode-txtbox-width'),
							$shortcodeTxtboxPadding = $('#cs-shortcode-txtbox-padding'),
							$shortcodeTxtboxBorder = $('#cs-shortcode-txtbox-border'),
							$shortcodeTxtboxFontsize = $('#cs-shortcode-txtbox-fontsize'),

							$widgetTxtboxWidth = $('#cs-widget-txtbox-width'),
							$widgetTxtboxPadding = $('#cs-widget-txtbox-padding'),
							$widgetTxtboxBorder = $('#cs-widget-txtbox-border'),
							$widgetTxtboxFontsize = $('#cs-widget-txtbox-fontsize'),

							$btn = $('#cs-btn'),
							$btnBg = $('#cs-btn-bg'),
							$btnPadding = $('#cs-btn-padding'),
							$btnColor = $('#cs-btn-color'),


							$dialog = $('#dialog-cs-addnew'),

							$data = {
								action          : 'sbp_cs_addnew',
								name            : $name.val(),

								homepage        : $homepage.is(':checked'),
								pages           : $pages.is(':checked'),
								pagesid         : $pagesid.val(),
								posts           : $posts.is(':checked'),
								postsid         : $postsid.val(),

								contents        : $contents,

								url             : $url.val(),
								term            : $term.val(),

								sTxtboxWidth    : $shortcodeTxtboxWidth.val(),
								sTxtboxPadding  : $shortcodeTxtboxPadding.val(),
								sTxtboxBorder   : $shortcodeTxtboxBorder.val(),
								sTxtboxFontsize : $shortcodeTxtboxFontsize.val(),

								wTxtboxWidth    : $widgetTxtboxWidth.val(),
								wTxtboxPadding  : $widgetTxtboxPadding.val(),
								wTxtboxBorder   : $widgetTxtboxBorder.val(),
								wTxtboxFontsize : $widgetTxtboxFontsize.val(),

								btn             : $btn.val(),
								btnBg           : $btnBg.val(),
								btnPadding      : $btnPadding.val(),
								btnColor        : $btnColor.val()
							};


						//* validation
						if ($url.val() == '') {
							$url.closest('div').addClass('error');
							$url.focus();
							return false;
						}
						else {
							$url.closest('div').removeClass('error');
						}

						if ($term.val() == '') {
							$term.closest('div').addClass('error');
							$term.focus();
							return false;
						}
						else {
							$term.closest('div').removeClass('error');
						}


						$dialog.empty().append('Submitting data... Please wait!');
						$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data, function(res) {
							if (res != 'done') {
								$dialog.empty().append('There was a problem submitting your data... Please wait!');
							}
							else {
								$dialog.empty().append('Data has been succesfully submitted.');
								window.location.href = '<?php echo admin_url('admin.php?page='. SBP_CODE); ?>';
							}
						});

						return false;
					});


					//* update status
					$('[id^=cmdUpdateCsStatus]').click(function() {
						var $this   = $(this),
							$id     = $this.attr('rel'),
							$span   = $this.children('span')

							$data   = {
								action  : 'sbp_cs_update_status',
								id      : $id
							};

						$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data);
						if ($span.hasClass('fg-green')) {
							$span.removeClass('fg-green').addClass('fg-red');
						}
						else {
							$span.removeClass('fg-red').addClass('fg-green');
						}
						return false;
					});

					//* delete
					$('[id^=cmdDeleteCs]').click(function() {
						var $this   = $(this),
							$id     = $this.attr('rel'),
							$tr     = $this.closest('tr'),

							$data   = {
								action  : 'sbp_cs_delete',
								id      : $id
							},

							q       = confirm('Are you sure you want to delete this item?');

						if (q) {
							$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data);
							$tr.slideUp();
						}
						return false;
					});


					//* copy shortcode
					var copyCsCode = new ZeroClipboard($('[id^=cmdCopyCsCode]'));
					copyCsCode.on('ready', function(ready) {
						copyCsCode.on('copy', function(event) {
							var clipboard = event.clipboardData;
							clipboard.setData('text/plain', '[sbp_cs id="'+ event.target.rel +'"]');
						}).on('aftercopy', function(event) {
							event.target.innerHTML = 'Copied!';
							setTimeout(function() {
								event.target.innerHTML = '<span class="dashicons dashicons-share"></span>';
							}, 1000);
						});
					});


					//* reset stat
					$('[id^=cmdResetCsStat]').click(function() {
						var $this   = $(this),
							$id     = $this.attr('rel'),

							$data   = {
								action  : 'sbp_cs_reset_stat',
								id      : $id
							},

							q       = confirm('Are you sure you want to reset stats for this item?');

						if (q) {
							$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data, function(res) {
								if (res == 'done') {
									$('#cs-impressions-'+ $id).empty().append(0);
									$('#cs-clicks-'+ $id).empty().append(0);
								}
							});
						}

						return false;
					});

					//* reset all stats
					$('#cmdResetCsAllStats').click(function() {
						var $this   = $(this),

							$data   = {
								action : 'sbp_cs_reset_all_stats'
							},

							q       = confirm('Are you sure you want to reset all stats?');

						if (q) {
							$.post('<?php echo admin_url('admin-ajax.php'); ?>', $data, function(res) {
								if (res == 'done') {
									$('[id^=cs-impressions-]').empty().append(0);
									$('[id^=cs-clicks-]').empty().append(0);
								}
							});
						}

						return false;
					});
				});
			</script>